﻿@*
    Strongly typed view
    Siia viewsse saan ma ainult panna kaasa @model taga kirjeldatud tüüpi objekti
*@
@model IEnumerable<AspNetCore.Models.Student>

@{
    ViewData["Title"] = "Index";
}

<h2>Index</h2>



@ViewData["Name"]
<p>
    <a href="http://www.delfi.ee">DELFI</a>
    <br />
    @* Tag Helpers
        Tee mulle link, mis suunab Create Actionisse
        Kui pole eraldi määratud, siis võetakse sama kontrolleri
        Action, kus me viibime
        asp-action ütleb actioni
        asp-controller ütleb kontrolleri
    *@
    <a asp-action="Create" asp-controller="Students" id="createLink">Create New</a>
    <br />
    @Html.ActionLink("Create New", "Create", "Students")
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Id)
            </th>
            <th>
                @* HTML Helpers
            DisplayNameFor annab mulle mudeli mingi konkreetse
            välja ehk klassi property nimetuse
             "FirstName"
                *@
                @Html.DisplayNameFor(model => model.FirstName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.LastName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Age)
            </th>
            <th>First Loan Description</th>
            <th></th>
        </tr>
    </thead>
    <tbody id="studentsTableBody">
        @foreach (var item in Model)
        {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Id)
            </td>
            <td>
                @* Html.DisplayFor annab mulle välja väärtuse *@
                @Html.DisplayFor(modelItem => item.FirstName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.LastName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Age)
            </td>

            <td>
                @if(item.Loans != null && item.Loans.Count > 0)
                {
                    @item.Loans[0].LoanType.Description;
                }

            </td>
            <td>
                @* asp-route-id ütleb siis et Edit action pane kaasa parameeter id
            ehk siis peale teist kaldkriipsu kolmas parameeter
            /Students/Edit/4
                *@
                <a asp-action="Edit" asp-route-id="@item.Id">Edit</a> |
                <a asp-action="Details" asp-route-id="@item.Id">Details</a> |
                @{
                    var id = "link_" + item.Id; // link_1 link_2
                }
                <a href="" id='@id' class='linkDeleteStudent'>Delete</a>
            </td>
        </tr>
                        }
    </tbody>
</table>

<input type="button" value="Sum loans" id="buttonSum" />
<input type="button" value="Add Student" id="buttonAddStudent" />
<div id="result"></div>

@section Scripts
{
    <script type="text/javascript">
        $(document).ready(function () {
            $('#buttonSum').click(function() {
                $.ajax({
                    type: 'GET',
                    url: '/Students/SumLoans',
                    success: function (result) {
                        // Tavaline javascript sama asja tegemiseks
                        //document.getElementById("result").innerHTML = result;
                        $('#result').html(result);
                        $('#createLink').html("Lisa uus kasutaja");
                        // Anna mulle kõik <a> tagid ehk kõik lingid
                        $('a').html("Lisa");
                      
                    }
                });
            });

            $('#buttonAddStudent').click(function () {
                $.ajax({
                    type: 'POST',
                    url: '@Url.Action("AddStudent")', // /Students/AddStudent
                    data: {
                        firstName: "Peeter",
                        lastName: "Paan",
                        age: 20,
                        isMarried: "true",
                    },
                    success: function (result) {
                        var tr = "<tr>";
                        tr += "<td>" + result.id + "</td>";
                        tr += "<td>" + result.firstName + "</td>";
                        tr += "<td>" + result.lastName + "</td>";
                        tr += "<td>" + result.age + "</td>";
                        tr += "<td>";
                        tr += "<a href = '/Students/Edit/" + result.id + "'> Edit</a> | ";
                        tr += "<a href = '/Students/Details/" + result.id + "'>Details</a> | ";
                        tr += "<a href='' id='link_" + result.id + "' class='linkDeleteStudent'>Delete</a>";
                        tr += "</td>";
                        tr += "</tr>";

                        $('#studentsTableBody')
                            .append(tr);
                    },
                    error: function (xhr, status, error) {
                        $('#result').html(xhr.responseText);
                    }
                });
            });

            //$('.linkDeleteStudent').click(function () {
            $(document).on('click', '.linkDeleteStudent', function (event) {
                // preventDefault() lülitab välja lingi sisseehitatud funktsionaalsuse
                // ehk siis antud juhul lingi aadressi "" avamise ehk sama lehe refreshi
                event.preventDefault();

                // this tähendab seda sama elmenti (link), millel ma klikin
                // küsin mis on selle konkreetse lingi id, millele ma klikkisin
                var id = this.id;
                $.ajax({

                    type: 'POST',
                    url: '@Url.Action("DeleteStudent")', // /Students/AddStudent
                    data: {
                        id : id.replace("link_", "")
                    },
                    success: function (result) {
                        $('#link_' + result).parent().parent().remove();
                    }
                });
            });
        });
           
        //});
    </script>
}
